/*
  example of use exception
*/

#include "newton.hh"
#include "myfunction.hh"
#include "ncfunction.hh"
#include <iostream>

using namespace std ;

int
main() {

  try {
    //MyFunction<double> fun(2) ;
    NC_Function<double> fun ;
    
    double x = newton( fun, 400.0, 100, 1e-12 ) ;
    cout << "x = " << x << '\n' ;
  }
  catch ( exception const & error ) {
    cerr << "Exception: " << error.what() << "\n"  ;
  }
  catch ( ... ) {
    cerr << "Exception found: Unknown error\n"  ;
  }
  cout << "END OF PROGRAM\n" ;

  return 0 ;
}

